
#define	REV_LIMIT2	0.04	/*** 1 / 5^2 ***/

#define	CALC_NORMAL	0
#define SKIP_ELECVDW	1

int
parse_qminterface(	char *keywordstr,char *reststr,
			STRUCT_ATOMDATA *atom_data,
			int *forceout_atoms,
			LOAD_MSG_ALL_NODE *global_data,
			STRUCT_FORCES *my_force,
			int *used_atoms);
int
set_qmboundbox( int *forceout_atoms,
		STRUCT_ATOMDATA *atom_data,
		LOAD_MSG_ALL_NODE *global_data);

int
add_qm_forces(	LOAD_MSG_ONE_NODE *my_data,
		LOAD_MSG_ALL_NODE *global_data,
		ENERGY_INFO *local_energy,
		STRUCT_FORCES *my_force,
		int *skipcounter);
		
int finish_qmcalculation(void);
		
int sort_to_qminfo(	int atom_id,int nodeatomindex,int node_number,
		   	STRUCT_QM_INFO *finfo,double *data,
		   	int incllen,int *incllist);
		   
int get_qmnode_index(int atom_id,LOAD_MSG_ONE_NODE *my_data);


int			
calculate_qmelec(int my_number,int my_atom,int my_unitnum,
		int other_atom,int other_unitnum,
		int copy_flag,
		LOAD_MSG_ALL_NODE *global_data,
		LOAD_MSG_ONE_NODE *my_data,
		TRAVELLING_PACKETS *packet);

int
write_force_header(FILE *hqmtraj,LOAD_MSG_ALL_NODE *global_data,
		int flag,int nr_atoms,
		char *headstr,char *flagstr);

int
handle_qmbond(	int *onthisnode,
		int *forceout_flag,
		int *myatom_id,
		LOAD_MSG_ONE_NODE *my_data,
		double *bforce,
		int ind1,int ind2);

int
handle_qmangles(int *onthisnode,int *forceout_flag,int *atom_id,
		LOAD_MSG_ONE_NODE *my_data,
		double cur_energy,double *f1,double *f3,int *ai);

int
handle_qmimpr(	int *onthisnode,int *forceout_flag,int *myatom_id,
		LOAD_MSG_ONE_NODE *my_data,
		double cur_energy,
		double *f1,double *f2,double *f3,double *f4,int *ai);
	
int
handle_qmdihe(	int *onthisnode,int *forceout_flag,int *myatom_id,
		LOAD_MSG_ONE_NODE *my_data,
		double cur_energy,
		double *f1,double *f2,double *f3,double *f4,int *ai);

int
set_qmexclusionatom(	int qmatom,int excluded_atom,
			LOAD_MSG_ALL_NODE *global_data,
			int excltype);
int
test_qmexclusion(int atomid);

int
add_qmexcl_list(int atom_id,LOAD_MSG_ONE_NODE *my_data);
