/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/


void	CalcIntern_ShortRange (	ENERGY_INFO *energy,
				LOAD_MSG_ONE_NODE *my_data,
				LOAD_MSG_ALL_NODE *global_data,
				TRAVELLING_FORCES *my_new_forces,
				double *rnd_force_std_deviation,
				double *Gamma);

void	CalcExtern_Bonds(	TRAVELLING_PACKETS *packet,
				LOAD_MSG_ALL_NODE *global_data,
				LOAD_MSG_ONE_NODE *my_data,
				int my_number);

void	CalcExtern_ShortRange(	LOAD_MSG_ONE_NODE *my_data,
				LOAD_MSG_ALL_NODE *global_data,
				EXT_3_ATOM *ext_angle,
				EXT_4_ATOM *ext_dihe,
				EXT_4_ATOM *ext_impr,
				int my_number);

void	CalcIntern_LongRange(	ENERGY_INFO *energy,
				LOAD_MSG_ALL_NODE *global_data,
				LOAD_MSG_ONE_NODE *my_data,
				TRAVELLING_FORCES *my_new_forces,
				int int_first);

void	CalcExtern_LongRange(	TRAVELLING_PACKETS *packet,
				ENERGY_INFO *energy,
				LOAD_MSG_ALL_NODE *global_data,
				LOAD_MSG_ONE_NODE *my_data,
				TRAVELLING_FORCES *my_new_forces,
				int my_number);

int	sort_to_pickbond(	int *myatom_id,
				double E, double *bforce,
				double R,
				STRUCT_PICK_BOND *pickbond);
