/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/


int TREE_calc_multipol (	int my_number,
				LOAD_MSG_ALL_NODE *global_data,
				TRAVELLING_PACKETS *packet);

int TREE_calc_LongRange (int	my_number,
			LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data,
			TRAVELLING_PACKETS *packet,
			int mode);

double get_min_unitdist(int flag,
		int my_atom,int other_unitnum,
		LOAD_MSG_ONE_NODE *my_data,
		TRAVELLING_PACKETS *packet);

int TREE_add_distforces (int my_number,
			LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data);

int TREE_calc_qmlocal(	int my_number,
			LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data);

int TREE_ini_all(	int my_number,
			LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data);

int TREE_exit(LOAD_MSG_ALL_NODE *global_data);

int TREE_update(	int my_number,
			LOAD_MSG_ALL_NODE *global_data,
			LOAD_MSG_ONE_NODE *my_data);

int TREE_start_loop(void);
