C***********************************************************************
      SUBROUTINE Center0(I1,I2,XAt,YAt,ZAt,RNam,XS)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),XS(3)
      CHARACTER*3  RNam(*)
      INTEGER      I,N
C-----------------------------------------------------------------------
      XS(1) = 0.0
      XS(2) = 0.0
      XS(3) = 0.0
      N = 0
      DO 100 I=I1,I2,1
        N = N+1
        XS(1) = XS(1)+XAt(I)
        XS(2) = XS(2)+YAt(I)
        XS(3) = XS(3)+ZAt(I)
  100 CONTINUE
C
      IF (N.GT.0) THEN
        XS(1) = XS(1)/FLOAT(N)
        XS(2) = XS(2)/FLOAT(N)
        XS(3) = XS(3)/FLOAT(N)
      ENDIF
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE FramIt0(I1,I2,XAt,YAt,ZAt,RNam,Fr)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),Fr(6)
      CHARACTER*3  RNam(*)
      INTEGER      I
C-----------------------------------------------------------------------
      Fr(1) = XAt(I1)
      Fr(2) = YAt(I1)
      Fr(3) = ZAt(I1)
      Fr(4) = XAt(I1)
      Fr(5) = YAt(I1)
      Fr(6) = ZAt(I1)
      DO 100 I=I1+1,I2,1
        IF (XAt(I).LT.Fr(1)) Fr(1) = XAt(I)
        IF (YAt(I).LT.Fr(2)) Fr(2) = YAt(I)
        IF (ZAt(I).LT.Fr(3)) Fr(3) = ZAt(I)
        IF (XAt(I).GT.Fr(4)) Fr(4) = XAt(I)
        IF (YAt(I).GT.Fr(5)) Fr(5) = YAt(I)
        IF (ZAt(I).GT.Fr(6)) Fr(6) = ZAt(I)
  100 CONTINUE
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE Center(I1,I2,XAt,YAt,ZAt,RNam,XS)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),XS(3)
      CHARACTER*3  RNam(*)
      INTEGER      I,N
C-----------------------------------------------------------------------
      XS(1) = 0.0
      XS(2) = 0.0
      XS(3) = 0.0
      N = 0
      DO 100 I=I1,I2,1
        IF ((RNam(I).NE.'H2O').AND.(RNam(I).NE.'TIP')) THEN
          N = N+1
          XS(1) = XS(1)+XAt(I)
          XS(2) = XS(2)+YAt(I)
          XS(3) = XS(3)+ZAt(I)
        ENDIF
  100 CONTINUE
C
      IF (N.GT.0) THEN
        XS(1) = XS(1)/FLOAT(N)
        XS(2) = XS(2)/FLOAT(N)
        XS(3) = XS(3)/FLOAT(N)
      ENDIF
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE FramIt(I1,I2,XAt,YAt,ZAt,RNam,Fr)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),Fr(6)
      CHARACTER*3  RNam(*)
      INTEGER      I0,I
C-----------------------------------------------------------------------
      DO 100 I=1,6,1
          Fr(I) = 0.0
  100 CONTINUE
C
      DO 150 I0=I1,I2,1
        IF ((RNam(I0).NE.'H2O').AND.(RNam(I0).NE.'TIP')) THEN
          Fr(1) = XAt(I0)
          Fr(2) = YAt(I0)
          Fr(3) = ZAt(I0)
          Fr(4) = XAt(I0)
          Fr(5) = YAt(I0)
          Fr(6) = ZAt(I0)
          GOTO 160
        ENDIF
  150 CONTINUE
  160 CONTINUE
C
      DO 200 I=I0+1,I2,1
        IF ((RNam(I).NE.'H2O').AND.(RNam(I).NE.'TIP')) THEN
          IF (XAt(I).LT.Fr(1)) Fr(1) = XAt(I)
          IF (YAt(I).LT.Fr(2)) Fr(2) = YAt(I)
          IF (ZAt(I).LT.Fr(3)) Fr(3) = ZAt(I)
          IF (XAt(I).GT.Fr(4)) Fr(4) = XAt(I)
          IF (YAt(I).GT.Fr(5)) Fr(5) = YAt(I)
          IF (ZAt(I).GT.Fr(6)) Fr(6) = ZAt(I)
        ENDIF
  200 CONTINUE
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE FramLip(I1,I2,XAt,YAt,ZAt,RNam,Fr)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),Fr(6)
      CHARACTER*3  RNam(*)
      INTEGER      I0,I
C-----------------------------------------------------------------------
      DO 100 I=1,6,1
          Fr(I) = 0.0
  100 CONTINUE
C
      DO 150 I0=I1,I2,1
        IF (RNam(I0).EQ.'LIP') THEN
          Fr(1) = XAt(I0)
          Fr(2) = YAt(I0)
          Fr(3) = ZAt(I0)
          Fr(4) = XAt(I0)
          Fr(5) = YAt(I0)
          Fr(6) = ZAt(I0)
          GOTO 160
        ENDIF
  150 CONTINUE
  160 CONTINUE
C
      DO 200 I=I0+1,I2,1
        IF (RNam(I).EQ.'LIP') THEN
          IF (XAt(I).LT.Fr(1)) Fr(1) = XAt(I)
          IF (YAt(I).LT.Fr(2)) Fr(2) = YAt(I)
          IF (ZAt(I).LT.Fr(3)) Fr(3) = ZAt(I)
          IF (XAt(I).GT.Fr(4)) Fr(4) = XAt(I)
          IF (YAt(I).GT.Fr(5)) Fr(5) = YAt(I)
          IF (ZAt(I).GT.Fr(6)) Fr(6) = ZAt(I)
        ENDIF
  200 CONTINUE
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE FramP43(I1,I2,XAt,YAt,ZAt,RNam,ANam,Fr)
      IMPLICIT NONE
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*),Fr(6)
      CHARACTER*3  RNam(*)
      CHARACTER*4  ANam(*)
      INTEGER      I0,I
C-----------------------------------------------------------------------
      DO 100 I=1,6,1
          Fr(I) = 0.0
  100 CONTINUE
C
      DO 150 I0=I1,I2,1
        IF ((RNam(I0).EQ.'LIP').AND.(ANam(I0).EQ.' P43')) THEN
          Fr(1) = XAt(I0)
          Fr(2) = YAt(I0)
          Fr(3) = ZAt(I0)
          Fr(4) = XAt(I0)
          Fr(5) = YAt(I0)
          Fr(6) = ZAt(I0)
          GOTO 160
        ENDIF
  150 CONTINUE
  160 CONTINUE
C
      DO 200 I=I0+1,I2,1
        IF ((RNam(I).EQ.'LIP').AND.(ANam(I).EQ.' P43')) THEN
          IF (XAt(I).LT.Fr(1)) Fr(1) = XAt(I)
          IF (YAt(I).LT.Fr(2)) Fr(2) = YAt(I)
          IF (ZAt(I).LT.Fr(3)) Fr(3) = ZAt(I)
          IF (XAt(I).GT.Fr(4)) Fr(4) = XAt(I)
          IF (YAt(I).GT.Fr(5)) Fr(5) = YAt(I)
          IF (ZAt(I).GT.Fr(6)) Fr(6) = ZAt(I)
        ENDIF
  200 CONTINUE
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE Retinal(NAt,XAt,YAt,ZAt,ANam,RNam)
      IMPLICIT NONE
      INTEGER      NAt
      REAL         XAt(*),YAt(*),ZAt(*)
      CHARACTER*4  ANam(*)
      CHARACTER*3  RNam(*)
      INTEGER      I
      REAL         delX,delY,delZ
C-----------------------------------------------------------------------
      delX = 0.0
      delY = 0.0
      delZ = 0.0
      I = 1
  100 CONTINUE
        IF (I.GT.NAt) RETURN
        IF ((RNam(I).EQ.'LYR').AND.(ANam(I).EQ.' NZ ')) THEN
          WRITE(6,'(A,3F6.2)') '  retinal N at ',
     @                         XAt(I),YAt(I),ZAt(I)
          WRITE(6,*)
          delX = XAt(I)
          delY = YAt(I)
          delZ = ZAt(I)
          GOTO 110
        ENDIF
        I = I+1
      GOTO 100
  110 CONTINUE
C
      WRITE(6,*) '  shifting molecule such that retinal N at origin...'
      DO 220 I=1,NAt,1
        XAt(I) = XAt(I)-delX
        YAt(I) = YAt(I)-delY
        ZAt(I) = ZAt(I)-delZ
  220 CONTINUE
      WRITE(6,*)
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE Repl(IRes,MXNAT,
     @                NAt,NRes,ANam,RNam,CNam,RId,XAt,YAt,ZAt,P1,P2)
C
C     Appends a copy of residue No IRes to the structure data.
C
      IMPLICIT NONE                                                             
      INTEGER      IRes,MXNAT,NAt,NRes
      CHARACTER*4  ANam(*)
      CHARACTER*3  RNam(*)
      CHARACTER*1  CNam(*)
      CHARACTER*5  RId(*)
      REAL         XAt(*),YAt(*),ZAt(*),P1(*),P2(*)
C
      CHARACTER*5  PRId
      INTEGER      I,IFir,ILas,KRes
C-----------------------------------------------------------------------
      DO 100 IFir=1,NAt,1
        READ(RId(IFir),'(I4,1X)') KRes
        IF (KRes.EQ.IRes) GOTO 110
  100 CONTINUE
      WRITE(6,*) '  Repl: WARNING, did not find residue to replicate!'
      WRITE(6,*)
      RETURN
C
  110 PRId = RId(IFir)
      DO 120 ILas=IFir,NAt,1
        IF (RId(ILas).NE.PRId) GOTO 130
  120 CONTINUE
      ILas = NAt+1
  130 ILas = ILas-1
C
      IF ((NAt+ILas-IFir+1).GT.MXNAT) THEN
        WRITE(6,*) '  Repl: ERROR, MXNAT = ',MXNAT,' exceeded!'
	WRITE(6,*) '  Increase MXNAT in main program and recompile!'
	WRITE(6,*)
        RETURN
      ENDIF
C
      NRes = NRes+1
      DO 200 I=IFir,ILas,1
        NAt = NAt+1
        ANam(NAt) = ANam(I)
        RNam(NAt) = RNam(I)
        CNam(NAt) = CNam(I)
        WRITE(RId(NAt),'(I4,1X)') NRes
        XAt(NAt) = XAt(I)
        YAt(NAt) = YAt(I)
        ZAt(NAt) = ZAt(I)
        P1(NAt) = P1(I)
        P2(NAt) = P1(I)
  200 CONTINUE
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE CopyXYZ(I1,I2,XAt,YAt,ZAt)
      IMPLICIT NONE                                                             
      INTEGER      I1,I2
      REAL         XAt(*),YAt(*),ZAt(*)
C-----------------------------------------------------------------------
      XAt(I2) = XAt(I1)
      YAt(I2) = YAt(I1)
      ZAt(I2) = ZAt(I1)
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE Shift(IAt,XAt,YAt,ZAt,dX,dY,dZ)
      IMPLICIT NONE
      INTEGER      IAt
      REAL         XAt(*),YAt(*),ZAt(*),dX,dY,dZ
C-----------------------------------------------------------------------
      XAt(IAt) = XAt(IAt)+dX
      YAt(IAt) = YAt(IAt)+dY
      ZAt(IAt) = ZAt(IAt)+dZ
C
      RETURN
      END
C
C
C***********************************************************************
      SUBROUTINE RotM(IAx,Ang,M)
C
C     Rotation operation is v' = M*v; looking down the rotation axis
C     from the positive end towards the negative end, the rotation
C     around that axis is done in the mathematical sense, i.e. counter-
C     clockwise (for Ang > 0, of course).
C
      IMPLICIT NONE
      INTEGER      IAx
      REAL         Ang,M(3,3)
      REAL         co,si
C-----------------------------------------------------------------------
      co = COS(Ang)
      si = SIN(Ang)
C
      IF (IAx.EQ.1) THEN
        M(1,1) = 1.0
        M(1,2) = 0.0
        M(1,3) = 0.0
        M(2,1) = 0.0
        M(2,2) = co
        M(2,3) = -si
        M(3,1) = 0.0
        M(3,2) = si
        M(3,3) = co
      ELSEIF (IAx.EQ.2) THEN
        M(1,1) = co
        M(1,2) = 0.0
        M(1,3) = si
        M(2,1) = 0.0
        M(2,2) = 1.0
        M(2,3) = 0.0
        M(3,1) = -si
        M(3,2) = 0.0
        M(3,3) = co
      ELSEIF (IAx.EQ.3) THEN
        M(1,1) = co
        M(1,2) = -si
        M(1,3) = 0.0
        M(2,1) = si
        M(2,2) = co
        M(2,3) = 0.0
        M(3,1) = 0.0
        M(3,2) = 0.0
        M(3,3) = 1.0
      ELSE
        WRITE(6,*) '  RotM: ERROR, do not understand IAx!'
      ENDIF
C
      RETURN
      END
C
C
C
C***********************************************************************
      SUBROUTINE Rotate(IAt,XAt,YAt,ZAt,XS,M)
      IMPLICIT NONE
      INTEGER      IAt
      REAL         XAt(*),YAt(*),ZAt(*),XS(3),M(3,3)
      REAL         dX,dY,dZ
C-----------------------------------------------------------------------
      dX = XAt(IAt)-XS(1)
      dY = YAt(IAt)-XS(2)
      dZ = ZAt(IAt)-XS(3)
C
      XAt(IAt) = XS(1)+M(1,1)*dX+M(1,2)*dY+M(1,3)*dZ
      YAt(IAt) = XS(2)+M(2,1)*dX+M(2,2)*dY+M(2,3)*dZ
      ZAt(IAt) = XS(3)+M(3,1)*dX+M(3,2)*dY+M(3,3)*dZ
C
      RETURN
      END
C
C
