      PROGRAM ADDSEG
      IMPLICIT NONE
      CHARACTER*80 Line,fnam
      CHARACTER*4  Str4
      INTEGER      I,N,NAtom
C
   10 WRITE(6,*) '  segment name (4 characters) to be added >'
      READ(5,'(A)',ERR=10) Str4
      WRITE(6,*)
   20 WRITE(6,*) '  psf input filename >'
      READ(5,'(A)',ERR=20) fnam
      WRITE(6,*)
      OPEN(71,FILE=fnam,STATUS='OLD',ERR=990)
   30 WRITE(6,*) '  psf output filename >'
      READ(5,'(A)',ERR=30) fnam
      WRITE(6,*)
      OPEN(81,FILE=fnam,STATUS='UNKNOWN')
C
  100 READ(71,'(A)',END=985,ERR=995) Line  
	WRITE(81,'(A)') Line
        IF (Line(10:15).EQ.'!NATOM') THEN
          READ(Line,*,ERR=980) NAtom
	  GOTO 200
        ENDIF
      GOTO 100
  200 CONTINUE
      WRITE(6,*) '  found NAtom = ',NAtom
      WRITE(6,*)
C
      N = 0
      DO 300 I=1,NAtom,1
        READ(71,'(A)',END=975,ERR=995) Line  
        IF (Line(70:70).NE.'0') THEN
          WRITE(6,*) '  WARNING: inconsistency in following line:'
	  WRITE(6,*) Line
	  WRITE(6,*)
	  WRITE(81,'(A)') Line
	ELSE
          WRITE(81,'(A,A,A)') Line(1:9),Str4,Line(14:80)
          N = N+1
	ENDIF
  300 CONTINUE
      WRITE(6,*) '  added segment name to ',N,' lines'
      WRITE(6,*)
C
  400 READ(71,'(A)',END=500,ERR=995) Line  
        WRITE(81,'(A)') Line
      GOTO 400
C
  500 CLOSE(71)
      CLOSE(81)
      STOP
C
  975 WRITE(6,*) '  addsegpsf: ERROR, hit end of file too early!'
      WRITE(6,*)
      STOP
  980 WRITE(6,*) '  addsegpsf: ERROR reading NAtom line!'
      WRITE(6,*)
      STOP
  985 WRITE(6,*) '  addsegpsf: ERROR, did not find NAtom line!'
      WRITE(6,*)
      STOP
  990 WRITE(6,*) '  addsegpsf: ERROR opening psf file!'
      WRITE(6,*)
      STOP
  995 WRITE(6,*) '  addsegpsf: ERROR reading psf file!'
      WRITE(6,*)
      STOP
C
      END
C
