/*
	This program "estp" takes as input Ego energy files output by the
	(/Users/heller/bin/) "wth" program and calculates the
	average time per step by adding the times and dividing by the
	number of steps.
	The times are given in the 2d column of every 4th line of the file.

	Brad Banko, 9/6/90
*/

#include	<stdio.h>
#include	<math.h>
#define		MAXLINE	120

void main()
{
	int steps;  float time;
	int t1,i; float t2;
	char line[MAXLINE];

	steps = 0;  time = 0.0;

	while ( fgets(line,MAXLINE,stdin) != NULL )
	{
		sscanf(line,"%d %f", &t1, &t2);
/*		printf("\n\nScanned '%s', got %d, %g\n", line, t1, t2); */
		time += t2; ++steps;
		for ( i=1; i<=3; ++i )
			if ( fgets(line,MAXLINE,stdin) == NULL ) {
				printf("\n*** ERROR during file read!\n");	
				break;
			};
	}

	printf("\nTotal time %g, Steps = %d => %g time/step\n\n",
		time, steps, time/steps);
}
