/*
#    Molecular Dynamics program EGO
#    Copyright (C) 1989  Markus Eichinger, Helmut Grubmueller, and Helmut Heller
#
#    official EGO web site: http://www.lrz.de/~heller/ego/
#
#    Contact the authors here:
#    Dr. Markus Eichinger:   entwicklung@eichinger-net.de
#    Dr. Helmut Grubmueller: hgrubmu@gwdg.de
#    Dr. Helmut Heller:      heller@lrz.de
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    For the full text of the license, see file LICENSE
#
#########################################################################
*/

#if defined(PARIX) || defined(MPI) || defined(PARIXHAL)
int	pvm_initsend(int size);
int	pvm_free(void);
int	pvm_buffer(void ** ptr);

void 	*pvm_set_readbuf(int size);

int	pvm_pkdouble (double *val,int count,int dummy);
int	pvm_upkdouble(double *val,int count,int dummy);

int	pvm_pkint (int *val,int count,int dummy);
int	pvm_upkint(int *val,int count,int dummy);

int	pvm_pkbyte (char *val,int count,int dummy);
int	pvm_upkbyte(char *val,int count,int dummy);

int	pvm_pkstr (char *str);
int	pvm_upkstr(char *str);

int	check_checksum();

#endif
