C  Dieses Programm liest Daten aus einem ASCII-file (extension .enr) 
C  und gibt es in ein file mit gleichem Namen (extension .dat)
C  in einem PLT2 gerechten Format (d.h. max. 6 Spalten) wieder aus
C
        INTEGER NFIELD,NDATA
	PARAMETER (NFIELD=14,NDATA=14)
	real value1(NDATA),value2(NDATA), skip
        integer row(NFIELD), ipos, k, count
	character*80 infile, outfile
C
        write(6,'('' data file ? (no extention)'')')
	read(5,'(A80)') infile
	ipos = index(infile,' ')
	outfile=infile
 	infile(ipos:ipos+3)='.enr'
	outfile(ipos:ipos+3)='.dat'
	open(1,file=infile,form='formatted',status='old')
	open(2,file=outfile,form='formatted',status='unknown')
        write(6,'(A,I2,A)') 'Number of columns to write? (<=',NFIELD,')'
        read(5,*) nrow 
        write(6,'('' Which points to write in each row (select)? '')')
	write(6,'(''Energies are in the order:'')')
	write(6,*) " 0: integration step number" 
	write(6,*) " 1: positive integration step number" 
	write(6,*) " 2: the time for this step" 
	write(6,*) " 3: the estat" 
	write(6,*) " 4: the vdW energy" 
	write(6,*) " 5: bonded" 
	write(6,*) " 6: angle" 
	write(6,*) " 7: dihedral" 
	write(6,*) " 8: improper" 
	write(6,*) " 9: restraint" 
	write(6,*) "10: SBOUND" 
	write(6,*) "11: hbond" 
	write(6,*) "12: kinetic" 
	write(6,*) "13: total" 
	write(6,*) "14: temperature" 
C
        read(5,*) (row(i),i=1,nrow) 
        write(6,'('' k (every k-th line to write) ? '')')
        read(5,*) k 
C        write(6,'('' skip (skip in time ) ? '')')
C        read(5,*) skip 
        skip=0.0
        write(6,'('' wait... '')')
	count = 0
	do while (.true.)
	   read (1,*,end=999) (value1(i),i=1,NDATA)
C	   read one input record
C
           do j=1,nrow
	     if (row(j) .eq. 0) then
              value2(j)=(value1(1))+skip
	     elseif (row(j) .eq. 1) then
              value2(j)=abs(value1(row(j)))+skip
             else
              value2(j)=value1(row(j))
             endif
           end do
C	   permutation of input columns
C
	   if (mod(count,k) .eq. 0) then
	    write(2,'(13(f14.4))') (value2(i),i=1,nrow)
C           write(6,*) value2(1)
           else
	    continue
           endif
	   count = count+1
	end do
999	close(1)
	close(2)

	stop
	end
